#ifndef _DIMENSION_FIELD_H_
#   define _DIMENSION_FIELD_H_

#include <qlineedit.h>

class DimensionFilter;
class QValidator;

typedef double (*FilterFunction)(void *clientData, double value);

class DimensionField : public QLineEdit
{
   Q_OBJECT

   public:

      static double nullFilter(void *clientData, double value);

      DimensionField(
         QWidget *parent,
         double value,
         const char *name   = 0,
         void *clientData   = 0,
         FilterFunction in  = nullFilter,
         FilterFunction out = nullFilter
      );

      ~DimensionField();

      void setFilters(FilterFunction in, FilterFunction out);

      double getValue();
      int setValue(double theValue);
      int isAcceptable();

   signals:
      void valueChanged(double currentValue);

   private slots:
      void slotHandleTextChanged(const QString &);

   private:
      DimensionField(const DimensionField &);
      DimensionField& operator=(const DimensionField &);

      int isAcceptable(const QString &s);

      double mValue;
      QValidator *mValidator;
      void *mClientData;
      FilterFunction mIn;
      FilterFunction mOut;
};
#endif
