#ifndef _COMPONENT_H_
#   define _COMPONENT_H_

#include <iostream>
using std::ostream;

class Component
{
   public:
      Component(
         int index,
         int defaultWidth,
         int defaultHeight
      );

      virtual ~Component();

      virtual double getLeft()   const = 0;
      virtual double getRight()  const = 0;
      virtual double getTop()    const = 0;
      virtual double getBottom() const = 0;
      virtual double getX()      const = 0;
      virtual double getY()      const = 0;
      virtual double getWidth()  const = 0;
      virtual double getHeight() const = 0;

      double getDefaultWidth()  const;
      double getDefaultHeight() const;

      virtual void setLocation(double x, double y) = 0;
      virtual void setSize(double width, double height) = 0;

      virtual int hasProperty(const char *propertyName) const = 0;
      virtual double getProperty(const char *propertyName) const = 0;

      int getIndex() const;

   private:
      int mIndex;
      int mDefaultWidth;
      int mDefaultHeight;
};

ostream &operator<<(ostream &out, const Component &);

#endif
