// C/C++ headers

#include <string.h>

// QALE headers

#include "Define.h"
#include "Node.h"

/*****************************************************************************
 * Definition of class: Define
 *****************************************************************************/

Define::Define(const char *name, const Node *value, int level)
   :
   mName(strcpy(new char[strlen(name) + 1], name)),
   mValue(value),
   mLevel(level)
{
   // Nothing to do
}

Define::~Define()
{
   // Must cast to non-const before deletion

   delete [] (char *)mName;
   delete (Node *)mValue;
}

const char *Define::getName()
{
   return(mName);
}

const Node *Define::getNode()
{
   return(mValue);
}

ostream &operator<<(ostream &out, const Define &d)
{
   char *indent = new char[d.mLevel + 1];

   for(int i = 0; i < d.mLevel; i ++)
      indent[i] = ' ';

   indent[d.mLevel] = '\0';

   out << indent << d.mName << " => " << *d.mValue;

   delete [] indent;

   return(out);
}
