#ifndef _MINMAX_NODE_H_
#   define _MINMAX_NODE_H_

#include "Node.h"
#include "Visitor.h"

class MinMaxNode : public Node
{
   public:
      typedef enum {

         _MIN_,
         _MAX_

      } Function;

      MinMaxNode(Function theFunction, Node *left, Node *right);
      ~MinMaxNode();

      double evaluate() const;

      ostream &print(ostream &out) const;

      Node *copy() const;

      void accept(Visitor &) const;

   private:
      MinMaxNode(const MinMaxNode &);
      MinMaxNode &operator=(const MinMaxNode &);

      Function mFunction;
      Node *mLeft;
      Node *mRight;
};
#endif
