// QALE headers

#include "UnaryNode.h"
#include "Visitor.h"

/*****************************************************************************
 * Definition of class: UnaryNode
 *****************************************************************************/

UnaryNode::UnaryNode(const Node *theNode)
   : mNode(theNode)
{
   // Nothing to do
}

UnaryNode::~UnaryNode()
{
   // Must cast to non-const before deletion

   delete (Node *)mNode;
}

double UnaryNode::evaluate() const
{
   return(-mNode->evaluate());
}

ostream &UnaryNode::print(ostream &out) const
{
   return(
      out << "-" << *mNode
   );
}

Node *UnaryNode::copy() const
{
   return(new UnaryNode(mNode->copy()));
}

void UnaryNode::accept(Visitor &v) const
{
   v.visited((UnaryNode *)this);
}
